﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Collections.ObjectModel
Imports System.Windows.Data
Imports System.Windows.Media.Effects

Namespace SilverlightApplication1
	Partial Public Class MainPage
		Inherits UserControl
		Private currentPoints As New ObservableCollection(Of TouchPoint)()
		Private primary As New TouchPoint()

		Public Sub New()
			InitializeComponent()
			AddHandler Touch.FrameReported, AddressOf Touch_FrameReported
			AddHandler Loaded, AddressOf MainPage_Loaded
		End Sub

		Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim data As New PagedCollectionView(currentPoints)
			data.GroupDescriptions.Add(New PropertyGroupDescription("Action"))
			TouchPointData.ItemsSource = data
		End Sub

		Private Sub Touch_FrameReported(ByVal sender As Object, ByVal e As TouchFrameEventArgs)

			For Each tp As TouchPoint In e.GetTouchPoints(Positions)
				If tp.Action = TouchAction.Down Then
					currentPoints.Add(tp)
					Dim pointLocation As New Ellipse()
					pointLocation.Tag = tp.TouchDevice.Id
					pointLocation.Name = tp.TouchDevice.Id.ToString()
					pointLocation.Width = 128
					pointLocation.Height = 128
					If (e.GetPrimaryTouchPoint(Positions) IsNot Nothing) Then
						If e.GetPrimaryTouchPoint(Positions).Position <> tp.Position Then
							pointLocation.Fill = New SolidColorBrush(Colors.White)
						Else
							pointLocation.Fill = New SolidColorBrush(Colors.Red)
						End If
					Else
						pointLocation.Fill = New SolidColorBrush(Colors.White)
					End If

					pointLocation.SetValue(Canvas.TopProperty, tp.Position.Y - 64)
					pointLocation.SetValue(Canvas.LeftProperty, tp.Position.X - 64)
					Dim dse As New DropShadowEffect()
					dse.BlurRadius = 100.0
					dse.Color = Colors.White
					dse.Direction = 0.0
					dse.ShadowDepth = 0.0
					pointLocation.Effect = dse
					Positions.Children.Add(pointLocation)
				ElseIf tp.Action = TouchAction.Up Then
					Positions.Children.Remove(CType(Me.FindName(tp.TouchDevice.Id.ToString()), UIElement))

					Dim p = From pts In currentPoints _
					        Where pts.TouchDevice.Id = tp.TouchDevice.Id _
					        Select pts

					currentPoints.Remove(p.First())
				ElseIf tp.Action = TouchAction.Move Then
					Dim el As Ellipse = (CType(Me.FindName(tp.TouchDevice.Id.ToString()), Ellipse))
					el.SetValue(Canvas.TopProperty, tp.Position.Y - 64)
					el.SetValue(Canvas.LeftProperty, tp.Position.X - 64)

					Dim p = From pts In currentPoints _
					        Where pts.TouchDevice.Id = tp.TouchDevice.Id _
					        Select pts

					currentPoints.Remove(p.First())
					currentPoints.Add(tp)
				End If
			Next tp
		End Sub
	End Class
End Namespace